<?php
/*
CMSimple simplerss plugin version 0.9
# 17.11.2007 / Karsten Doerges / www.cycronic.de
# HTML clean up
# minor bug fixes
# re-package 

CMSimple simplerss plugin version 0.8_modified
# 18.11.2006 by T. Schuster / www.nmud.de
# removal of "vas" bug from extlib/rss_fetch.inc
# char setting possible from  within configurations

CMSimple simplerss plugin version 0.8 
# 10.01.2006 / Karsten Doerges / www.cycronic.de
# updated Snoopy class 
# updated MagPieRSS class
# Admin cache

CMSimple simplerss plugin version 0.7 
# 02.01.2006 / Karsten Doerges / www.cycronic.de
# cleanup code

CMSimple simplerss plugin version 0.5b 
# 27.08.2005 / Karsten Doerges / www.cycronic.de
# danish language, thanks to Geniz
# auto detect description length  

CMSimple simplerss plugin version 0.5
# 19.08.2005 / Karsten Doerges / www.cycronic.de
# config item length
# select & show whole item

CMSimple simplerss plugin version 0.2c
# 18.08.2005 / Karsten Doerges / www.cycronic.de
# show source url

CMSimple simplerss plugin version 0.2b
# 17.08.2005 / Karsten Doerges / www.cycronic.de
# css styles for channel and item
# configure channel output
# show feed language as flag (deu, eng, fr-be, dk)

CMSimple simplerss plugin version 0.1 
# 16.08.2005 / Karsten Doerges / www.cycronic.de
# the first version
# based on MagPie
*/

/**
 * Display a number of RSS feeds in a cmsimple page
 * 
 * @access public
 * @param string $sNumbers
 * @return string 
 */   	
function showrss($iNumber)
{
	// we need some global vars
    global $plugin_cf, $plugin_tx, $tx, $sn, $su, $pth, $hjs;

	// Start Content
	// init var
    $iStart = 0;

	// get starting point from globalpost		
    $iStart = isset($_POST['stcon']) ? $_POST['stcon'] : $_GET['stcon'];
    $iMsg   = isset($_POST['msg']) ? $_POST['msg'] : $_GET['msg'];		

	// if we have no starting point, we will start with first item		
    if (!isset($iStart)) 
    {
    	$iStart=0;
    }
	if (!isset($iMsg)) 
	{
		$iMsg=0;
	}
		
	// used for navigation
	if ($iStart==1)
	{
		$iStart=0;
	}

	// get plugin name, prevent us from using static name		
    $sPlugin = basename(dirname(__FILE__),"/");

	// get plugin vars from config 		
    $source_array = explode(",", $plugin_cf[$sPlugin]['source_array']);		
    $use_description = $plugin_cf[$sPlugin]['use_description'];
    $iItem_count = $plugin_cf[$sPlugin]['item_count'];
				
	$page = "<p>".$plugin_tx[$sPlugin]['message']."</p>";

		
	// don't touch this / MagPie path definitions		
    define('MAGPIE_DIR', './plugins/'.$sPlugin.'/extlib/');
	define('MAGPIE_CACHE_DIR', './plugins/'.$sPlugin.'/cache/');

	// include magpie helper
	include_once(MAGPIE_DIR.'rss_fetch.inc');
		
	// get vars from config
    $sUsecache = $plugin_cf[$sPlugin]['cache_on'];
    
    // if you want to use the internal cache system
    // ++ will speed up your system
    // ++ don't forget to grant write permission to your cache folder 
    if ($sUsecache == 'yes') 
    {
        define('MAGPIE_CACHE_ON', true);
		// get max age of cache
        $iCacheage = $plugin_cf[$sPlugin]['cache_age'];        
		// if max time not set or not numeric; set to 60
        if (($iCacheage = '') || (!is_numeric($iCacheage))) 
        {
            $iCacheage = 60;	
        }
	    define('MAGPIE_CACHE_AGE', $iCacheage);
    } 
    else 
    {
        define('MAGPIE_CACHE_ON', false);    
        define('MAGPIE_CACHE_AGE', '0'); 	
    }
	define('MAGPIE_DEBUG', true);

	// take care if there are any http auth infos
    $proxy_user = $plugin_cf[$sPlugin]['proxy_user'];        
    $proxy_pass = $plugin_cf[$sPlugin]['proxy_pass'];

	// take care if there are any http auth infos
    $proxy_host = $plugin_cf[$sPlugin]['proxy_host'];        
    $proxy_port = $plugin_cf[$sPlugin]['proxy_port'];

	// set charset form config or fallback
	if ($plugin_cf['simplerss']['charset'] <> '')
	{
		define('MAGPIE_OUTPUT_ENCODING', $plugin_cf['simplerss']['charset']);
	}
	else
	{
		// FallBack
		define('MAGPIE_OUTPUT_ENCODING', "iso-8859-1");
	}

	// fetch feed from external source 
	$rss = fetch_rss( $source_array[$iNumber], "", $proxy_user, $proxy_pass, $proxy_host, $proxy_port );

	// get logo pref from config file
	if (($rss->image['url'] != '') && ($plugin_cf[$sPlugin]['channel_logo'] == 'yes')) 
	{
	    $bShow_logo = true;
	}
	else
	{
		$bShow_logo = false;
	}

	// start channel section
    $page .=  "<p class=\"channel\"><table><tr>\n";

	if ($bShow_logo == true) 
	{
	    $page .= "<td valign=\"top\"><img src=\"".$rss->image['url']."\" alt=\"RSS: ".$rss->channel['title']."\" align=\"left\"></td>\n";
	}

    if (($plugin_cf[$sPlugin]['channel_language'] == 'yes') || ($plugin_cf[$sPlugin]['show_source'] == 'yes')) 
    {
	    $page .= "<td width=\"32\" valign=\"top\" align=\"center\">";
        if (($rss->channel['language'] != '') && ($plugin_cf[$sPlugin]['channel_language'] == 'yes')) 
        {
	        $page .= code2flag($rss->channel['language']);
		}

		if ($plugin_cf[$sPlugin]['show_source'] == 'yes') 
		{
		    $page .= "<a href=\"".$source_array[$iNumber]."\" target=\"_new\"><img src=\"plugins/$sPlugin/images/rss.gif\" alt=\"RSS Source\"></a>";
		}
        $page .= "</td>\n";
    }
		
	$page .= "<td valign=\"top\"><a href=\"".$rss->channel['link']."\" target=\"_new\" >" . $rss->channel['title'] . "</a>";
    
    // show channel description
	if (($rss->channel['description'] != '') && ($plugin_cf[$sPlugin]['channel_description'] == 'yes')) 
	{
        $page .= "<br>".$rss->channel['description'];
	}
		
	$page .= "</td>\n";
	$page .= "</tr></table>\n";

	// End channel section		
	// Start item section
		
    $page .=  "<div class=\"items\"><ul>";
	$iCount = 0;
	$iCounthits = 1;
	// crawl through array of items and render
	foreach ($rss->items as $aItem) 
	{
	    $iCount++;
	    // urlencode link with out protocoll
	    $sHref = str_replace("&", "&amp;", $aItem['link']);
		$sTitle = $aItem['title'];	
		$sDesc = $aItem['description'];
		if ($iMsg == '0') 
		{
			// 0 = listmode
		    if (($iItem_count >= $iCounthits) && ($iCount >= $iStart)) 
		    {
				// count views ++
			    $iCounthits++;
				// show title + description (opt)
                if ($use_description == 'yes') 
                { 
                	// decide if images inside description should be shown or not
                	if ($plugin_cf[$sPlugin]['image_description'] != 'yes')
                		$sDesc = strip_tags($sDesc);
                		
    			    if ($plugin_cf[$sPlugin]['skip_description'] == '0') 
    			    {
    		            $page .= "<li><a class=\"item\" href=\"$sHref\" target=\"_new\">$sTitle</a><br>". $sDesc . "</li>\n";
					} 
					else 
					{
						// if description too long, skip
					    if (strlen($sDesc) > $plugin_cf[$sPlugin]['skip_description']) 
					    {
    		                $page .= "<li><a class=\"item\" href=\"$sHref\" target=\"_new\">$sTitle</a><br>".substr(strip_tags($sDesc), 0, $plugin_cf[$sPlugin]['skip_description'])."...";
                            $page .= "<br>";
							$page .= "[ <a href=\"".$sn."?".$su."&amp;msg=".$iCount."&amp;stcon=".$iStart."\">".$plugin_tx[$sPlugin]['read_more']."</a> ]";
						} 
						else 
						{
    		                $page .= "<li><a class=\"item\" href=\"$sHref\" target=\"_new\">$sTitle</a><br>".$sDesc;												
						}
						$page .= "<br><br></li>\n";								
					} // skip ?
				} 
				else 
				{
		            $page .= "<li><a class=\"item\" href=$sHref target=\"_new\">$sTitle</a><br><br></li>\n";				
				} // desc ?
			} // show frame?
		} 
		else 
		{
			// > 0 = messagemode
            if ($iMsg == $iCount) 
            {
				// selected message?
                $page .= "<li><a class=\"item\" href=$sHref target=\"_new\">$sTitle</a><br>".$sDesc."</li>\n";								
            }  // fi				
		}	// fi mode	
    } // foreach
	$page .= "</ul></div>\n";
		
	// Navigation
    if ($iMsg == 0) 
    {
        if ($plugin_cf[$sPlugin]['show_navigation'] == 'yes') 
        {
            $page .= "<p class=\"navigation\">";
		    $page .= $plugin_tx[$sPlugin]['content_nav'];
            if ($iStart-$iItem_count > 0) 
            {
			    $low = $iStart-$iItem_count;
				$page .= "<a href=\"".$sn."?".$su."&amp;stcon=".$low."\">&lt;&lt;</a>";
			} 
			else 
			{
			    $page .= "&lt;&lt;";				
			}								
			$page .= "&nbsp;|&nbsp;";
			if ($iCount-($iStart+$iItem_count) > 0) 
			{
				if ($low == 0) 
				{
					$low = $iStart+$iItem_count+1;
				} 
				else 
				{
					$low = $iStart+$iItem_count;						
				}
				$page .= "<a href=\"".$sn."?".$su."&amp;stcon=".$low."\">&gt;&gt;</a>";
			} 
			else 
			{
				$page .= "&gt;&gt;";				
			}								
		    $page .= "</p>\n";
		}		
	} 
	else 
	{
		$page .= "<p class=\"navigation\">";
		$page .= "<a href=\"".$sn."?".$su."&amp;stcon=".$iStart."\">".$plugin_tx[$sPlugin]['content_return']."</a></p>\n";				
	}
    return $page;
}

/**
 * map a language code to a flag
 * 
 * @access public
 * @param string $sCode
 * @return string $sImg 
 */
function code2flag($sCode) 
{
    $sPlugin = basename(dirname(__FILE__),"/");

    switch ($sCode) 
    {
		// Danish
        case "da":
            $sImg = "<img src=\"plugins/$sPlugin/images/flags/da.png\" alt=\"Danish\">";
			break;
		// General German
	    case "de":
            $sImg = "<img src=\"plugins/$sPlugin/images/flags/deu-deu.png\" alt=\"Deutsch\">";
			break;
		// German: Germany
	    case "de-de":
            $sImg = "<img src=\"plugins/$sPlugin/images/flags/deu-deu.png\" alt=\"Deutsch\">";
			break;
		// French: Belgium			
		case "fr-be":
		    $sImg = "<img src=\"plugins/$sPlugin/images/flags/fr-be.png\" alt=\"Belgium\">";			
			break;
		// General english			
		case "en":
		    $sImg = "<img src=\"plugins/$sPlugin/images/flags/en.png\" alt=\"English\">";			
			break;

		// English: UK			
		case "en-gb":
		    $sImg = "<img src=\"plugins/$sPlugin/images/flags/en.png\" alt=\"English - UK\">";			
			break;

		// English: USA
		case "en-us":
		    $sImg = "<img src=\"plugins/$sPlugin/images/flags/en.png\" alt=\"American english\">";			
			break;
		// Default: Show language code
		default:
            $sImg = "[".$sCode."]";			
			break;
    }
    return $sImg;
}
?>
